package dev.shadowsoffire.apotheosis.adventure.commands;

import java.util.Arrays;
import net.minecraft.world.entity.ai.attributes.AttributeModifier;
import net.minecraftforge.registries.ForgeRegistries;
import java.util.stream.Stream;
import net.minecraft.commands.SharedSuggestionProvider;
import java.util.function.Function;
import net.minecraft.resources.ResourceLocation;
import java.util.concurrent.CompletableFuture;
import com.mojang.brigadier.suggestion.SuggestionsBuilder;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.Gem;
import com.mojang.brigadier.exceptions.CommandSyntaxException;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.player.Player;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemRegistry;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.function.Predicate;
import com.mojang.brigadier.context.CommandContext;
import com.mojang.brigadier.arguments.ArgumentType;
import net.minecraft.commands.arguments.ResourceLocationArgument;
import net.minecraft.commands.Commands;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import net.minecraft.commands.CommandSourceStack;
import com.mojang.brigadier.suggestion.SuggestionProvider;

public class GemCommand
{
    public static final SuggestionProvider<CommandSourceStack> SUGGEST_OP;
    public static final SuggestionProvider<CommandSourceStack> SUGGEST_ATTRIB;
    public static final SuggestionProvider<CommandSourceStack> SUGGEST_GEM;
    
    public static void register(final LiteralArgumentBuilder<CommandSourceStack> root) {
        root.then(((LiteralArgumentBuilder)((LiteralArgumentBuilder)Commands.m_82127_("gem").requires(c -> c.m_6761_(2))).then(Commands.m_82127_("fromPreset").then(Commands.m_82129_("gem", (ArgumentType)ResourceLocationArgument.m_106984_()).suggests((SuggestionProvider)GemCommand.SUGGEST_GEM).executes(c -> {
            final Gem gem = (Gem)GemRegistry.INSTANCE.getValue(ResourceLocationArgument.m_107011_(c, "gem"));
            final Player p = (Player)((CommandSourceStack)c.getSource()).m_81375_();
            final ItemStack stack = GemRegistry.createGemStack(gem, LootRarity.random(p.f_19796_, p.m_36336_()));
            p.m_36356_(stack);
            return 0;
        })))).then(Commands.m_82127_("random").executes(c -> {
            final Player p = (Player)((CommandSourceStack)c.getSource()).m_81375_();
            final ItemStack gem = GemRegistry.createRandomGemStack(p.f_19796_, ((CommandSourceStack)c.getSource()).m_81372_(), p.m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches(p.m_9236_()), GameStagesCompat.IStaged.matches(p) });
            p.m_36356_(gem);
            return 0;
        })));
    }
    
    static {
        SUGGEST_OP = ((ctx, builder) -> SharedSuggestionProvider.m_82981_((Stream)Arrays.stream(AttributeModifier.Operation.values()).map((Function<? super AttributeModifier.Operation, ?>)Enum::name), builder));
        SUGGEST_ATTRIB = ((ctx, builder) -> SharedSuggestionProvider.m_82981_((Stream)ForgeRegistries.ATTRIBUTES.getKeys().stream().map(ResourceLocation::toString), builder));
        SUGGEST_GEM = ((ctx, builder) -> SharedSuggestionProvider.m_82981_((Stream)GemRegistry.INSTANCE.getKeys().stream().map(ResourceLocation::toString), builder));
    }
}
